#include "theBiasPlanet/coreUtilities/stringsHandling/StringHandler.hpp"
#include <iomanip>
#include <iostream>

using namespace ::std;

namespace theBiasPlanet {
	namespace coreUtilities {
		namespace stringsHandling {
			template <typename T, typename ... U> ostringstream * StringHandler::format (ostringstream * const a_resultStream, istringstream * const a_formatStream, T const & a_currentItem, U const & ... a_remainderItems) {
				if (a_formatStream != nullptr) {
					char l_character = (char) -1;
					bool l_leftPadsItemWith0 = false;
					bool l_lengthOfNumberItemExpressionIsSpecified = false;
					int l_lengthOfNumberItemExpression = -1;
					int l_precisionOfNumberItemExpression = -1;
					ostringstream l_dummyStreamForStoringFormat (string (""));
					l_dummyStreamForStoringFormat.copyfmt (*a_resultStream);
					while (a_formatStream->get (l_character)) {
						if (l_character == '%') {
							if (a_formatStream->get (l_character)) {
								if (l_character != '%') {
									if (l_character == '0') {
										l_leftPadsItemWith0 = true;
										l_lengthOfNumberItemExpressionIsSpecified = true;
										l_lengthOfNumberItemExpression = 0;
									}
									else {
										l_leftPadsItemWith0 = false;
										if (l_character >= '0' && l_character <= '9') {
											l_lengthOfNumberItemExpressionIsSpecified = true;
											l_lengthOfNumberItemExpression = l_character - '0';
										}
										else {
										}
									}
									if (l_lengthOfNumberItemExpressionIsSpecified) {
										while (a_formatStream->get (l_character)) {
											if (l_character >= '0' && l_character <= '9') {
												if (l_precisionOfNumberItemExpression == -1) {
													l_lengthOfNumberItemExpression = l_lengthOfNumberItemExpression * 10 + (l_character - '0');
												}
												else {
													l_precisionOfNumberItemExpression = l_precisionOfNumberItemExpression * 10 + (l_character - '0');
												}
											}
											else {
												if (l_character == '.') {
													l_precisionOfNumberItemExpression = 0;
												}
												else {
													break;
												}
											}
										}
										if (l_leftPadsItemWith0) {
											(*a_resultStream) << setfill ('0');
										}
										(*a_resultStream) << setw (l_lengthOfNumberItemExpression);
										if (l_precisionOfNumberItemExpression != -1) {
											(*a_resultStream) << fixed << setprecision (l_precisionOfNumberItemExpression);
										}
									}
									if (l_character == 'd') {
										(*a_resultStream) << dec;
									}
									if (l_character == 'x') {
										(*a_resultStream) << uppercase << hex;
									}
									(*a_resultStream) << a_currentItem;
									a_resultStream->copyfmt (l_dummyStreamForStoringFormat);
									return format (a_resultStream, a_formatStream, a_remainderItems ...);
								}
								else {
									(*a_resultStream) << l_character;
								}
							}
							else {
								(*a_resultStream) << l_character;
							}
						}
						else {
							(*a_resultStream) << l_character;
						}
					}
					(*a_resultStream) << a_currentItem;
					return format (a_resultStream, a_formatStream, a_remainderItems ...);
				}
				else {
					(*a_resultStream) << a_currentItem;
					return format (a_resultStream, a_formatStream, a_remainderItems ...);
				}
			}
			
			template <typename T, typename ... U> string StringHandler::format (string const & a_formatString, T const & a_currentItem, U const & ... a_remainderItems) {
				ostringstream l_resultStream;
				istringstream l_formatStream (a_formatString);
				format (&l_resultStream, &l_formatStream, a_currentItem, a_remainderItems ...);
				return l_resultStream.str ();
			}
		}
	}
}

